## pound-3.0.1-1.src.tar.gz

=== CMakeLists.txt ===
# tunable variables - regenerate pound.h for it to take effect
set (VERSION "3.0.1")
set (MAXBUF 8192)
set (MAXHEADERS 128)
set (RESURRECT_CYCLE 60)
set (RESURRECT_TO 15)
set (HASH_FUNCTION HASH_FNV)
set (LOG_FACILITY LOG_DAEMON)
set (H2TABSIZE 4096)
set (H2FRAMESIZE 16384)

# from here on there should be nothing to change
cmake_minimum_required(VERSION 3.0)
project(Pound C)

if (CMAKE_C_COMPILER_ID STREQUAL "Clang" OR CMAKE_C_COMPILER_ID STREQUAL "GCC" OR CMAKE_C_COMPILER_ID STREQUAL "GNU")
set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-unused-result -Wno-cast-qual -Wno-discarded-qualifiers -D_GNU_SOURCE -O2")
endif()

include_directories(include)

file(GLOB SOURCES "src/*.c")

add_executable(pound ${SOURCES})

set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
set(THREADS_PREFER_PTHREAD_FLAG TRUE)
find_package(Threads REQUIRED)

include(CheckIncludeFiles)
CHECK_INCLUDE_FILES("stdio.h;pthread.h;yaml.h;nanomsg/nn.h;nanomsg/inproc.h;nanomsg/pipeline.h;nanomsg/pair.h;nanomsg/reqrep.h;stdlib.h;unistd.h;fcntl.h;ctype.h;getopt.h;string.h;syslog.h;sys/types.h;sys/socket.h;netdb.h;sys/stat.h;time.h;poll.h;semaphore.h;pwd.h;grp.h;signal.h;setjmp.h;mbedtls/config.h;mbedtls/certs.h;mbedtls/oid.h;mbedtls/asn1.h;mbedtls/x509.h;mbedtls/entropy.h;mbedtls/ctr_drbg.h;mbedtls/ssl.h;mbedtls/error.h" HAVE_MANDATORY_INCLUDES LANGUAGE C)
if(NOT HAVE_MANDATORY_INCLUDES)
message(FATAL_ERROR "Missing mandatory header files!")
endif()

CHECK_INCLUDE_FILES(pcreposix.h HAVE_PCREPOSIX_H)
CHECK_INCLUDE_FILES(pcre/pcreposix.h HAVE_PCRE_PCREPOSIX_H)
CHECK_INCLUDE_FILES(regex.h HAVE_REGEX_H)
CHECK_INCLUDE_FILES(stdarg.h HAVE_STDARG_H)

CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/include/pound.h.in ${CMAKE_CURRENT_SOURCE_DIR}/include/pound.h)
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/MKDIST.in ${CMAKE_CURRENT_SOURCE_DIR}/MKDIST)

target_link_libraries(pound -lyaml)
target_link_libraries(pound -lnanomsg)
target_link_libraries(pound -lpthread)
target_link_libraries(pound Threads::Threads)

FIND_LIBRARY(TCMALLOC tcmalloc )
if(TCMALLOC)
target_link_libraries(pound -ltcmalloc)
endif()

FIND_LIBRARY(MBEDCRYPTO mbedcrypto)
if(MBEDCRYPTO)
target_link_libraries(pound -lmbedcrypto)
endif()

FIND_LIBRARY(MBEDX509 mbedx509)
if(MBEDX509)
target_link_libraries(pound -lmbedx509)
endif()

FIND_LIBRARY(MBEDTLS mbedtls)
if(MBEDTLS)
target_link_libraries(pound -lmbedtls)
endif()

if(NOT MBEDCRYPTO OR NOT MBEDX509 OR NOT MBEDTLS)
message(FATAL_ERROR "Missing mandatory library MbedTLS!")
endif()

if(HAVE_PCREPOSIX_H OR HAVE_PCRE_PCREPOSIX_H)
FIND_LIBRARY(PCRE pcreposix)
if(PCRE)
target_link_libraries(pound -lpcreposix)
else()
message(FATAL_ERROR "pcreposix.h found but libpcreposix is not available!")
endif()
endif()

=== PKGBUILD ===
# Maintainer: David Runge <dvzrv@archlinux.org>
# Contributor: Sergej Pupykin <pupykin.s+arch@gmail.com>
# Contributor: Douglas Soares de Andrade <dsa@aur.archlinux.org>
# Contributor: Roberto Alsina <ralsina@kde.org>

_name=Pound
pkgname=pound
pkgver=3.0.1
pkgrel=1
pkgdesc="A reverse proxy, load balancer, and SSL wrapper"
arch=('x86_64')
url="https://www.apsis.ch/pound.html"
license=('GPL3')
depends=('gcc-libs' 'glibc' 'libyaml' 'nanomsg' 'pcre')
makedepends=('cmake' 'gperftools' 'mbedtls' 'uthash')
backup=("etc/${pkgname}/${pkgname}.yaml")
source=("http://www.apsis.ch/${pkgname}/${_name}-${pkgver}.tgz"
        "${_name}-${pkgver}.tgz.asc::http://www.apsis.ch/${pkgname}/${_name}-${pkgver}.asc"
        "${pkgname}-3.0-runtime_dir.patch"
        "${pkgname}.service"
        "${pkgname}.yaml")
sha512sums=('85a3a3ec41ec26574b18cd7e304c82fe5bd3cc2699f3ffbbdf9bc2378cd4820d3c9a2fac702ee1de03209f0c050fa4e9baaae5612bf1fd87a6bc31316681bf9c'
            'SKIP'
            '25db5c13750c2770ae5a91d850f2f00e888474a05b2464c6f03ebe4dc628c86edf8df640daa96e9dcb7240de43537a731671376f20e0dfb599ef5fc2eaf6c053'
            '887ebace94fb6974b34e096c3f9d85e7e45186f816f8a0b4218ffecf2bf041702bc5d40547ca5883691e1d5f959e28b8ce3aac0f12c877760c0e80d8319f57e9'
            '329fb0064f9720cc41332894d3e96e098ffd789d13bcb3b35d67dd9f7b4c0667d1b4cf1d93df9427b4e867d5f0b5857be412ae8d34abed5aa3c2774a499b3292')
b2sums=('6e6cfa8832cbbf462a8df69fc76e8e5c15685d9640c51e3c85b1d9db8e3c6182093f601fd167738f067669126c4ea5c9dc5d3eb8acc64e39b9e1a9f3561a6c4f'
        'SKIP'
        'eba66845b02eff8cea9353f1617f9fcbce040609ea22a1061d98a69c109fed1aaaf6fb338cde1c969153df383def7ae5e3231f281140d32702acfb8c628fa0e4'
        '886e7218d0098f86edfde32b0d8ccdf47f7a8d6a3417144bbd9279cac14d51065fe72b312844ff6a24be6d16183a3b4a44b0d012c1d08808d07ea96d660ff69f'
        'a7ebb7714abf8bc7c2c0f627f6fdcc226a293277a98455bd52340536754ef3a5aef75340b8535402c78a9a754f78d4793c1d7b0c15b0b8d393fd3760a6398858')
validpgpkeys=('8BB562A0F1DB703FB7EB1E95AB72C62A8691DD02') # Robert Segall <roseg@apsis.ch>

prepare() {
  mv -v "${_name}-${pkgver}" "${pkgname}-${pkgver}"
  cd "${pkgname}-${pkgver}"
  # set runtime dir to /run/pound
  patch -Np1 -i "../${pkgname}-3.0-runtime_dir.patch"
  # remove vendored uthash so we build with the packaged version
  rm -v include/ut{hash,array}.h
}

build() {
  cd "${pkgname}-${pkgver}"
  cmake -DCMAKE_INSTALL_PREFIX=/usr \
        -DCMAKE_BUILD_TYPE='None' \
        -Wno-dev \
        -B build \
        -S .
  make VERBOSE=1 -C build
}

package() {
  depends+=('libmbedtls.so' 'libmbedcrypto.so' 'libmbedx509.so'
  'libtcmalloc.so')

  cd "${pkgname}-${pkgver}"
  # cmake setup has no install target :(
  install -vDm 755 build/"${pkgname}" -t "${pkgdir}/usr/bin/"
  # configuration
  install -vDm 644 "../${pkgname}.yaml" -t "${pkgdir}/etc/${pkgname}/"
  # systemd service
  install -vDm 644 "../${pkgname}.service" \
    -t "${pkgdir}/usr/lib/systemd/system/"
  # man page
  install -vDm 644 man/${pkgname}.8 -t "${pkgdir}/usr/share/man/man8/"
  # docs
  install -vDm 644 README.md \
    -t "${pkgdir}/usr/share/doc/${pkgname}/"
}
